import { Component } from '@angular/core';
import { NavController } from 'ionic-angular';
import { DefaultListable } from '../../defaults/default-listable';
import { INavigable } from '../../interfaces/navigable-interface';
import { Product } from '../../models/product';
import { ProductDetailsPage } from '../product-details/product-details';
import { DataProvider } from '../../providers/data-provider'

@Component({
    selector: 'page-product-list',
    providers: [DataProvider],
    templateUrl: 'product-list.html'
})
export class ProductListPage extends DefaultListable<Product> implements INavigable {

    constructor(public navCtrl: NavController, public data: DataProvider) {
        super();

        this.initialize();
    }

    /**
     * Initialize data list
     */
    initialize(): void {
        this.data.getAll('product').then(r => { 
            this.elements = r.products;
        });
    }

    /**
     * Goto page
     */
    goToPage(page: any) {
        this.navCtrl.push(ProductDetailsPage);
    }
}
